<! requires
  user >

$$set back=/apps/admin/;

<html>
<head>
<title>Zeus Admin Controller - Security settings</title>
</head>

<body bgcolor=#ffffff>

<table>
<tr>
  <td valign=top> 
   <img src="title.gif" hspace=10>
   <p align=right>
   <a href="/apps/admin/index.zap"><img src="back.gif" alt="[back]" align=bottom border=0 hspace=10></a>
  </td>
  <td valign=top>

<br>
<img src="security-title.gif">
<p>

This page allows you to change a variety of options to configure the
security of the Administration server to your requirements.

<dl>
<dt><b><font size=+1>Access restrictions</b></font>
<dd>

Access restrictions can be placed upon the IP addresses and/or DNS
addresses of clients who can contact the Network registry server.  By
default, only connections originating on the local machine are allowed
to contact the network registry interface, but if you wish to
centralise control of many Zeus Applications distributed over a
network of machines, you will need to specify which machines can
retrieve configuration settings.  For more information about
distributed configuration, please see the documentation system.

<p>

Access is granted if their IP <b>or</b> DNS addresses matches.  If
both the DNS and IP boxes are blank, they will match everything.
IP address may be a prefix of IP addresses you wish to match
(i.e. entering <tt>10.25.</tt> will match <tt>10.25.0.2</tt>), and DNS
addresses may be a suffix (i.e. entering <tt>.zeus.co.uk</tt> will
match <tt>hera.zeus.co.uk</tt>).  Multiple IP or DNS addresses may be
specified by separating them with a comma.

<p>

Access to localhost is always allowed to prevent complete lockout from
the system.  However you should be careful altering these options if
you are accessing this system from a different machine.

<p>

These alterations will not take effect until the adminserver is restarted.

<!---------------------------->

$$set _base=conf!reg;
<form action="/apps/admin/regupdate.cgi" method=POST>
<input type=hidden name="_base" value="$$_base;">
<input type=hidden name="_redirect" value="$$back;">

<dl>

<dt><b>Network registry restrictions</b>
<dd>

<table>
<tr>
  <td>IP:</td>
  <td>
  <input type=text name="allow!_add_text_IP" value="$$allow!IP;">
  </td>
</tr>
<tr>
  <td>DNS:</td>
  <td>
  <input type=text name="allow!_add_text_DNS" value="$$allow!DNS;">
  </td>
</tr>
</table>

</dl>

<input type=submit value=Update>
</form>

<!---------------------------->

<dt><b><font size=+1>SSL operation</b></font>
<dd>

The administration server can be setup so the web interface runs over
SSL providing even more security.  If enabled, access to the
administration server is via 'https://' instead of 'http://'.
<p>
These alterations will not take effect until the admin server is restarted.

<p>

Keys may be created using the command line <tt>cert</tt> utility or
using the <a href="/apps/admin/certs/">web-based certificate
generation</a> page.

<p>
$$set _base=conf!admin!security;
<form action="/apps/admin/regupdate.cgi" method=post>
<input type=hidden name="_base" value="$$_base;">
<input type=hidden name="_redirect" value="$$back;">

<input type=hidden name=_add_boolean_enabled value=no>

<b>Enabled:</b>
<input type=checkbox name=_add_boolean_enabled value=yes 
 $$if enabled=yes; checked $$endif;>

<p>

<dl>
<dt><b>Public Certificate File</b>

<dd>
This is the name of the file that contains the X509 Certificate which contains your public key.<br>

<input type=text value="$$public_key;" size=40 name=_add_text_public_key>

<p><dt><b>Private Key File</b>

<dd>
This is the name of the file that contains the RSA Private Key.<br>
<input type=text value="$$private_key;" size=40 name=_add_text_private_key>

</dl>

<p>
<input type=submit value=Update>
</form>

<!---------------------------------------------------------->

<dt><b><font size=+1>Change password</b></font>
<dd>

Please enter the new password in both boxes.
<br>

Only if both boxes are the same will the password be updated.<p>
This alteration will take effect immediately.

<form method=post action=passwd.zap>
<input type=hidden name=branch value="conf!reg!users">

<table cellpadding=0 cellspacing=0>
<tr>
  <td>
    User:
  </td>
  <td>
    <input type=text name=user value="$$user;">
  </td>
</tr>
<tr>
  <td>
    New password:
  </td>
  <td>
    <input type=password name=pw1 value="">
  </td>
</tr>
<tr>
  <td>
    New password:
  </td>
  <td>
    <input type=password name=pw2 value="">
  </td>
</tr>
</table>
<p>
<input type=submit value="Update">
</form>
 

</dl>

</table>

</body>
</html>

