<%
## Deletes a website from the webserver
## If successful, redirect to controller, else displays error
##
## Arguments
##  server

zap::getrequest { server }
set server $asp::input(server)

# Check if it is currently running
set running() {}

# Attempt to get secret key if available
set secret ""
catch { set secret [read [open "$request::env(ZEUSHOME)/web/etc/secret"]] }

foreach host [zap::reglist dynamic!apps!web] {
    set port [zap::regget "dynamic!apps!web!$host"]
    # Try to connect to host:port to work out what is running
    catch {
	set s [ socket $host $port ]
	puts $s "${secret}info\n"; flush $s
	set data [ read $s ]
	foreach line [ split $data \n ] { set running($line) 1 }
    }
}

if { [info exists running($server)] } {
    zap::error "This website is currently running, please stop the website
    before attempting to delete it."
}

# OK, its not running, its safe to delete it
if { [ catch { reg::delete "conf!web!servers!$server" } result ] } {
    zap::error "Error deleting website <b>$server</b> : $result"
}
# Delete optional stuff
catch [ reg::delete "dynamic!web-modules!$server" ]

# All done
asp::redirect "/apps/web/"
%>
