<%
# First off, ensure this page isn't cached, otherwise it can be very
# confusing!

response::setheader "Pragma" "no-cache"
response::setheader "Expires" \
  [clock format [clock seconds] -format "%a, %d %b %Y %T %Z" -gmt yes]
%>

<html>
<head>
<title>Zeus Web Server Controller</title>
</head>

<body bgcolor="#ffffff" link=#990066 vlink=#990066 alink=#990066>

<table border=0>
<tr>
  <td valign=top>
    <img src="title.gif" hspace=10 alt="">
    <p align=right>
  <a
  href="/apps/admin/docsystem/context.asp?help=/apps/web/docs/controller/controller.html" target=help onClick=
  "window.open('','help','resizable=1,width=640,height=500'); return true;">
<img src="/apps/web/docs.gif" 
  alt="[documentation]" align=bottom border=0 hspace=0></a>
    <a href="/"><img src="back.gif" alt="[back]" align=bottom border=0 hspace=0></a>
  </td>
  <td>

<img src="status.gif" alt="Status"><p>

<%
#############################################################################
# Attempts to connect with a timeout, either errors or returns a 
# socket channel (blocking)
#
proc connect_timeout { host port timeout } {
    global connect_timeout ;# global table for our state info
    set connect_timeout(connected) ""
    set connect_timeout(socket) [socket -async $host $port]
    set t [expr $timeout*1000]
    set connect_timeout(timeoutid) [after $t { 
	close $connect_timeout(socket)
	set connect_timeout(connected) "no"
    }]
    fileevent $connect_timeout(socket) writable { 
	after cancel $connect_timeout(timeoutid)
	set connect_timeout(connected) "yes"
    }
    # Now wait if we didn't manage it straight away....
    if { $connect_timeout(connected) == "" } { 
	vwait connect_timeout(connected) 
    }
    if { $connect_timeout(connected) == "yes" } { 
	# Ensure we are back blocking again
	fconfigure $connect_timeout(socket) -blocking yes 
	return $connect_timeout(socket) 
    }
    error "Connect timeout"
}

#############################################################################
# Routines to determine which sites to render

namespace eval sites {
    variable startsite 
    variable endsite   
    variable pagesize  10
    variable oldpagesize 10
    variable sitelist
    variable banner ""

    ########################################################################
    # Determines values for startsite & endsite from arguments

    proc init { sites } {
	variable startsite
	variable endsite
	variable siteslist
	variable pagesize
	variable oldpagesize

	set siteslist $sites
	set startsite 0
	set endsite [expr [llength $siteslist] -1]
	if { $endsite == -1 } { set endsite 0 }

	asp::decode_input
	if { [info exists asp::input(start)] } { 
	    set startsite $asp::input(start)
	}
	if { [info exists asp::input(pagesize)] } {
	    set pagesize $asp::input(pagesize)
	}
	if { [info exists asp::input(oldpagesize)] } {
	    set oldpagesize $asp::input(oldpagesize)
	}

	if { $startsite > $endsite } {
	    set startsite [expr $endsite - $pagesize + 1 ]
	    if { $startsite < 0 } { set startsite 0 }
	}
	if { $pagesize!=-1 && [expr $startsite + $pagesize - 1] < $endsite } {
	    set endsite [expr $startsite + $pagesize - 1]
	}
    }

    ########################################################################
    # Returns 1 if it all fits on one page

    proc fits {} {
	variable startsite
	variable endsite
	variable siteslist

	if { $startsite == 0 && $endsite == [expr [llength $siteslist]-1] } {
	    return 1
	} else { return 0 }
    }

    ########################################################################
    # Given a list of websites in sorted order, chooses which ones we want to
    # display

    proc choose {} {
	variable startsite
	variable endsite
	variable siteslist

	return [lrange $siteslist $startsite $endsite]
    }

    ########################################################################
    # Draws a header bar

    proc header {} {
	variable banner
	variable pagesize
	variable oldpagesize

	if { $banner != "" } { 
	    # Cached
	    asp::write $banner
	    return
	}

	if { $pagesize == -1 } {
	    set banner ""
	    append banner "<a href=\"index.zap?pagesize=$oldpagesize\">Back to partial display</a>"
	    asp::write $banner
	}

	if { [fits] } { return }

	variable startsite
	variable endsite
	variable siteslist
	variable pagesize

	set prevpage [expr $startsite - $pagesize]
	if { $prevpage < 0 } { set prevpage 0 }
	set nextpage [ expr $startsite + $pagesize]

	append banner "<font size=-1>"
	if { $startsite != 0 } {
	    append banner "<a href=\"index.zap?start=0&pagesize=$pagesize\">&lt;&lt;</a> | "
	    append banner "<a href=\"index.zap?start=$prevpage&pagesize=$pagesize\">&lt;</a> | "
	} else {
	    append banner "<font color=gray>&lt;&lt;</font> | "
	    append banner "<font color=gray>&lt;</font> | "
	}

	# Now the quick jump ones
	foreach section [list AF GL MR SZ] {
	    set start [string index $section 0]
	    set end   [string index $section 1]
	    set index 0
	    foreach site $siteslist {
		set usite [string toupper $site]
		if { $usite >= $start } { break }
		incr index
	    }
	    append banner " <a href=
	    \"index.zap?start=$index&pagesize=$pagesize\">$start-$end</a> | "
	}

	if { $endsite != [expr [llength $siteslist]-1] } {
	    append banner "<a href=\"index.zap?start=$nextpage&pagesize=$pagesize\">&gt;</a>"
	    append banner " | <a href=\"index.zap?start=[expr [llength $siteslist]-$pagesize]&pagesize=$pagesize\">&gt;&gt;</a>"
	} else {
	    append banner "<font color=gray>&gt;</font>"
	    append banner " | <font color=gray>&gt;&gt;</font>"
	}
	append banner " | <a href=\"index.zap?pagesize=-1&oldpagesize=$pagesize\">ALL</a>";
	append banner "</font>"
	asp::write $banner
    }

    ########################################################################
    # Draws a footer bar
    
    proc footer {} { header }
}

## Check if we have clustering installed

set cluster 0
if { [ zap::regget "conf!web!cluster!enabled" ] == "yes" } { set cluster 1 }

############################################################################
# Need to render some traffic lights showing the status of the servers.
#
# A table of running servers
set running() {}
# non-zero if any webserver processes are alive
set webserver_alive 0
# Host:port of machine to ask what's running
set host ""
set port ""
# Attempt to get secret key if available
set secret ""
catch { set secret [read [open "$request::env(ZEUSHOME)/web/etc/secret"]] }
#
if { $cluster } {
    # If we are clustering, we ask the cluster master frontend what's running
    set host [zap::regget "dynamic!cluster!master"]
    if { $host != "" } { set port [zap::regget "dynamic!apps!cluster!$host"] }
    if { $port == "" } { set host "" }
} else {
    # No clustering, just ask the first webserver what's going on
    set host [lindex [zap::reglist "dynamic!apps!web"] 0]
    if { $host != "" } { set port [zap::regget "dynamic!apps!web!$host"] }
    if { $port == "" } { set host "" }
}
# Now we know who to connect to
if { $host != "" } {
    # Try to connect to host:port to work out what its running
    catch { 
	set s [ connect_timeout $host $port 2 ]
	puts $s "${secret}info\n"; flush $s
	set data [ read $s ]

	foreach server [ split $data \n ] {
	    if { [ llength $server ] == 0 } { continue }
	    set running($server) 1
	}
	# the command worked, so this webserver must be alive...
	incr webserver_alive
    }
} else {
    # No webserver processes are running
}
#############################################################################

# Depending on whether the webserver is running or not, provide
# a link to start or stop the webserver process.
# Note this is different in the clustering case

if { $webserver_alive } {
    asp::write "Webserver running"
    if { !$cluster } { asp::write " (<a href=\"http.cgi?stop\">Stop</a>)" }
} else {
    asp::write "Webserver not running"
    if { !$cluster } { asp::write " (<a href=\"http.cgi?start\">Start</a>)" }
}

## --------
## TODO: this is a little bit of a hack.  When we startup the webserver
## process, we need to clear all of the modified flags.  However, http.cgi
## doesn't have access to the adminserver password etc, otherwise it could
## use regcmd to do it for us.
## So, if the server isn't running, we force all the modified flags to
## be no here.

if { ! $webserver_alive } {
    foreach i [zap::reglist "conf!web!servers" ] {
	catch { reg::set "conf!web!servers!$i!modified" "no" }
    }
}

## --------

asp::write "<p>"

# Now draw the result tables, with the appropriatly coloured
# traffic lights depending on what is going on.  At this point
# running and webserver_alive are accurate

set configuredservers [zap::reglist conf!web!servers]
if { [llength $configuredservers] == 0 } {
    # No websites setup
    asp::write "<i>No servers available to configure, please 
    <a href=new.asp>create one</a>.</i>"
} else {
    # Have some websites
    sites::init [lsort -dictionary $configuredservers]
    asp::write "<center>\n";
    sites::header
    asp::write "<table border=1 cellspacing=1 cellpadding=5>\n"
    foreach server [sites::choose] {
	# Draw website $server
	set branch "conf!web!servers!$server"
	set port   [zap::regget "$branch!port" ]
	set ipname [zap::regget "$branch!ip_name" ]
	set secure [zap::regget "$branch!security!enabled" ]

	# Work out the name of the website
	set name "http://$ipname"
	if { $secure == "yes" } { 
	    set name "https://$ipname"
	    if { $port != "443" } { append name ":$port" }
	} else {
	    if { $port != 80 } { append name ":$port" }
	}

	# Work out the graphics and alt tags, and the click action location
	set alt ""
	set graphic ""
	# TODO, need to set this action jobbie soon...
	set action ""

	if { $webserver_alive } {
	    if { [info exists running($server)] } {
		set alt     "running"
		set graphic "green.gif"
		set action  "website.zap?website=$server&action=stop"
	    } else {
		set alt     "stopped"
		set graphic "red.gif"
		set action  "website.zap?website=$server&action=start"
	    }
	} else {
	    if { [zap::regget "$branch!running"] == "yes" } {
		set alt     "was running"
		set graphic "green_grayed.gif"
	    } else {
		set alt     "was stopped"
		set graphic "red_grayed.gif"
	    }
	}

	# Now draw the cells
	asp::write "<tr><td><a href=\"$action\"><img border=0 src=\"$graphic\"
	alt=\"\[$alt\]\"></a></td>"

	asp::write "<td>$server"
	if { [zap::regget "$branch!modified"] == "yes" } { 
	    asp::write " <i>(modified)</i>";
	}
	asp::write "<br><i>"
	if { $webserver_alive && [info exists running($server)] } {
	    asp::write "<a href=\"$name\" target=\"running website\">$name</a>"
	} else {
	    asp::write "<font color=#808080>$name</font>"
	}
	asp::write "</i></td>"

	asp::write "<td><a href=\"edit.zap?server=$server\">
	<img src=edit.gif border=0 alt=\"\[edit\]\"></a></td></tr>"
    }
    asp::write "</table>"

    sites::footer
    asp::write "</center>"
}
%>

<p><br><img src="actions.gif" alt="Actions"><p>

<center>
<table cellspacing=10>
<tr>
  <td align=center>
  <a href=new.asp><img src="button-new.gif" alt="" border=0></a>
  </td>
  <td align=center> 
  <a href=global.asp><img src="button-global.gif" alt="" border=0></a>
  </td>
<% if { $cluster } { asp::write "
  <td align=center>
  <a href=cluster/status.zap><img src=cluster/button-cluster.gif alt=\"\" border=0></a>
  </td>
" } %>
</tr>

<tr>
  <td align=center>
  <a href=new.asp>New server</a><br>
  </td>
  <td align=center>
  <a href=global.asp>Global settings</a><br>
  </td>
<% if { $cluster } { asp::write "
  <td align=center>
  <a href=cluster/status.zap>Clustering</a><br>
  </td>
" } %>

</tr>
</table>

</center>

</td>
</tr>
</table>


</body>
</html>
