#!/bin/sh

# This script adds a new virtual server from the command line
# It's designed for ISPs who might need to create a lot of servers


usage()
{
  echo
  echo "Adds a new virtual server"
  echo Usage: $0 '<name> <docroot> <ipname> <port> [passwd]'
  echo
  exit
}


getpassword()
{
 prompt=$1
 printf "$prompt"
 stty -echo
 read VALUE
 stty echo
 echo
}


if [ $# -ne 4  -a $# -ne 5  ]
then
  usage
fi

# Take the arguments
NAME=$1
DOCROOT=$2
IPNAME=$3
PORT=$4  
PASSWD=$5


# check ZEUSHOME is set
if [ -z "$ZEUSHOME" ]
then
  echo "Please set \$ZEUSHOME to point to the directory under which Zeus applications are installed"
  exit 1
fi


PATH=$ZEUSHOME/bin:$PATH
cd $ZEUSHOME

reset()
{
  stty echo
  exit
}

# if we don't have a password from the command line, then prompt for one
if [ -z "$PASSWD" ]
then
  trap reset INT
  getpassword "Enter admin passwd: "
  PASSWD=$VALUE
fi

UPDATE="regcmd -user admin -pass $PASSWD -"

# Copy across the defaults from the skel dir
echo 'copy conf!web!skel conf!web!servers!'$NAME | $UPDATE

# add the extra settings
echo 'add conf!web!servers!'$NAME'!docroot text '$DOCROOT | $UPDATE
echo 'add conf!web!servers!'$NAME'!ip_name text '$IPNAME  | $UPDATE
echo 'add conf!web!servers!'$NAME'!port text '$PORT | $UPDATE




